package com.mvc.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class FacUserRoleExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public FacUserRoleExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("ID is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("ID >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("ID <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andRoleIdIsNull() {
            addCriterion("ROLE_ID is null");
            return (Criteria) this;
        }

        public Criteria andRoleIdIsNotNull() {
            addCriterion("ROLE_ID is not null");
            return (Criteria) this;
        }

        public Criteria andRoleIdEqualTo(String value) {
            addCriterion("ROLE_ID =", value, "roleId");
            return (Criteria) this;
        }

        public Criteria andRoleIdNotEqualTo(String value) {
            addCriterion("ROLE_ID <>", value, "roleId");
            return (Criteria) this;
        }

        public Criteria andRoleIdGreaterThan(String value) {
            addCriterion("ROLE_ID >", value, "roleId");
            return (Criteria) this;
        }

        public Criteria andRoleIdGreaterThanOrEqualTo(String value) {
            addCriterion("ROLE_ID >=", value, "roleId");
            return (Criteria) this;
        }

        public Criteria andRoleIdLessThan(String value) {
            addCriterion("ROLE_ID <", value, "roleId");
            return (Criteria) this;
        }

        public Criteria andRoleIdLessThanOrEqualTo(String value) {
            addCriterion("ROLE_ID <=", value, "roleId");
            return (Criteria) this;
        }

        public Criteria andRoleIdLike(String value) {
            addCriterion("ROLE_ID like", value, "roleId");
            return (Criteria) this;
        }

        public Criteria andRoleIdNotLike(String value) {
            addCriterion("ROLE_ID not like", value, "roleId");
            return (Criteria) this;
        }

        public Criteria andRoleIdIn(List<String> values) {
            addCriterion("ROLE_ID in", values, "roleId");
            return (Criteria) this;
        }

        public Criteria andRoleIdNotIn(List<String> values) {
            addCriterion("ROLE_ID not in", values, "roleId");
            return (Criteria) this;
        }

        public Criteria andRoleIdBetween(String value1, String value2) {
            addCriterion("ROLE_ID between", value1, value2, "roleId");
            return (Criteria) this;
        }

        public Criteria andRoleIdNotBetween(String value1, String value2) {
            addCriterion("ROLE_ID not between", value1, value2, "roleId");
            return (Criteria) this;
        }

        public Criteria andRoleNameIsNull() {
            addCriterion("ROLE_NAME is null");
            return (Criteria) this;
        }

        public Criteria andRoleNameIsNotNull() {
            addCriterion("ROLE_NAME is not null");
            return (Criteria) this;
        }

        public Criteria andRoleNameEqualTo(String value) {
            addCriterion("ROLE_NAME =", value, "roleName");
            return (Criteria) this;
        }

        public Criteria andRoleNameNotEqualTo(String value) {
            addCriterion("ROLE_NAME <>", value, "roleName");
            return (Criteria) this;
        }

        public Criteria andRoleNameGreaterThan(String value) {
            addCriterion("ROLE_NAME >", value, "roleName");
            return (Criteria) this;
        }

        public Criteria andRoleNameGreaterThanOrEqualTo(String value) {
            addCriterion("ROLE_NAME >=", value, "roleName");
            return (Criteria) this;
        }

        public Criteria andRoleNameLessThan(String value) {
            addCriterion("ROLE_NAME <", value, "roleName");
            return (Criteria) this;
        }

        public Criteria andRoleNameLessThanOrEqualTo(String value) {
            addCriterion("ROLE_NAME <=", value, "roleName");
            return (Criteria) this;
        }

        public Criteria andRoleNameLike(String value) {
            addCriterion("ROLE_NAME like", value, "roleName");
            return (Criteria) this;
        }

        public Criteria andRoleNameNotLike(String value) {
            addCriterion("ROLE_NAME not like", value, "roleName");
            return (Criteria) this;
        }

        public Criteria andRoleNameIn(List<String> values) {
            addCriterion("ROLE_NAME in", values, "roleName");
            return (Criteria) this;
        }

        public Criteria andRoleNameNotIn(List<String> values) {
            addCriterion("ROLE_NAME not in", values, "roleName");
            return (Criteria) this;
        }

        public Criteria andRoleNameBetween(String value1, String value2) {
            addCriterion("ROLE_NAME between", value1, value2, "roleName");
            return (Criteria) this;
        }

        public Criteria andRoleNameNotBetween(String value1, String value2) {
            addCriterion("ROLE_NAME not between", value1, value2, "roleName");
            return (Criteria) this;
        }

        public Criteria andRoleFlagIsNull() {
            addCriterion("ROLE_FLAG is null");
            return (Criteria) this;
        }

        public Criteria andRoleFlagIsNotNull() {
            addCriterion("ROLE_FLAG is not null");
            return (Criteria) this;
        }

        public Criteria andRoleFlagEqualTo(String value) {
            addCriterion("ROLE_FLAG =", value, "roleFlag");
            return (Criteria) this;
        }

        public Criteria andRoleFlagNotEqualTo(String value) {
            addCriterion("ROLE_FLAG <>", value, "roleFlag");
            return (Criteria) this;
        }

        public Criteria andRoleFlagGreaterThan(String value) {
            addCriterion("ROLE_FLAG >", value, "roleFlag");
            return (Criteria) this;
        }

        public Criteria andRoleFlagGreaterThanOrEqualTo(String value) {
            addCriterion("ROLE_FLAG >=", value, "roleFlag");
            return (Criteria) this;
        }

        public Criteria andRoleFlagLessThan(String value) {
            addCriterion("ROLE_FLAG <", value, "roleFlag");
            return (Criteria) this;
        }

        public Criteria andRoleFlagLessThanOrEqualTo(String value) {
            addCriterion("ROLE_FLAG <=", value, "roleFlag");
            return (Criteria) this;
        }

        public Criteria andRoleFlagLike(String value) {
            addCriterion("ROLE_FLAG like", value, "roleFlag");
            return (Criteria) this;
        }

        public Criteria andRoleFlagNotLike(String value) {
            addCriterion("ROLE_FLAG not like", value, "roleFlag");
            return (Criteria) this;
        }

        public Criteria andRoleFlagIn(List<String> values) {
            addCriterion("ROLE_FLAG in", values, "roleFlag");
            return (Criteria) this;
        }

        public Criteria andRoleFlagNotIn(List<String> values) {
            addCriterion("ROLE_FLAG not in", values, "roleFlag");
            return (Criteria) this;
        }

        public Criteria andRoleFlagBetween(String value1, String value2) {
            addCriterion("ROLE_FLAG between", value1, value2, "roleFlag");
            return (Criteria) this;
        }

        public Criteria andRoleFlagNotBetween(String value1, String value2) {
            addCriterion("ROLE_FLAG not between", value1, value2, "roleFlag");
            return (Criteria) this;
        }

        public Criteria andCreateManIsNull() {
            addCriterion("CREATE_MAN is null");
            return (Criteria) this;
        }

        public Criteria andCreateManIsNotNull() {
            addCriterion("CREATE_MAN is not null");
            return (Criteria) this;
        }

        public Criteria andCreateManEqualTo(String value) {
            addCriterion("CREATE_MAN =", value, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManNotEqualTo(String value) {
            addCriterion("CREATE_MAN <>", value, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManGreaterThan(String value) {
            addCriterion("CREATE_MAN >", value, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManGreaterThanOrEqualTo(String value) {
            addCriterion("CREATE_MAN >=", value, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManLessThan(String value) {
            addCriterion("CREATE_MAN <", value, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManLessThanOrEqualTo(String value) {
            addCriterion("CREATE_MAN <=", value, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManLike(String value) {
            addCriterion("CREATE_MAN like", value, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManNotLike(String value) {
            addCriterion("CREATE_MAN not like", value, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManIn(List<String> values) {
            addCriterion("CREATE_MAN in", values, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManNotIn(List<String> values) {
            addCriterion("CREATE_MAN not in", values, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManBetween(String value1, String value2) {
            addCriterion("CREATE_MAN between", value1, value2, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManNotBetween(String value1, String value2) {
            addCriterion("CREATE_MAN not between", value1, value2, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andAccAuthIsNull() {
            addCriterion("ACC_AUTH is null");
            return (Criteria) this;
        }

        public Criteria andAccAuthIsNotNull() {
            addCriterion("ACC_AUTH is not null");
            return (Criteria) this;
        }

        public Criteria andAccAuthEqualTo(String value) {
            addCriterion("ACC_AUTH =", value, "accAuth");
            return (Criteria) this;
        }

        public Criteria andAccAuthNotEqualTo(String value) {
            addCriterion("ACC_AUTH <>", value, "accAuth");
            return (Criteria) this;
        }

        public Criteria andAccAuthGreaterThan(String value) {
            addCriterion("ACC_AUTH >", value, "accAuth");
            return (Criteria) this;
        }

        public Criteria andAccAuthGreaterThanOrEqualTo(String value) {
            addCriterion("ACC_AUTH >=", value, "accAuth");
            return (Criteria) this;
        }

        public Criteria andAccAuthLessThan(String value) {
            addCriterion("ACC_AUTH <", value, "accAuth");
            return (Criteria) this;
        }

        public Criteria andAccAuthLessThanOrEqualTo(String value) {
            addCriterion("ACC_AUTH <=", value, "accAuth");
            return (Criteria) this;
        }

        public Criteria andAccAuthLike(String value) {
            addCriterion("ACC_AUTH like", value, "accAuth");
            return (Criteria) this;
        }

        public Criteria andAccAuthNotLike(String value) {
            addCriterion("ACC_AUTH not like", value, "accAuth");
            return (Criteria) this;
        }

        public Criteria andAccAuthIn(List<String> values) {
            addCriterion("ACC_AUTH in", values, "accAuth");
            return (Criteria) this;
        }

        public Criteria andAccAuthNotIn(List<String> values) {
            addCriterion("ACC_AUTH not in", values, "accAuth");
            return (Criteria) this;
        }

        public Criteria andAccAuthBetween(String value1, String value2) {
            addCriterion("ACC_AUTH between", value1, value2, "accAuth");
            return (Criteria) this;
        }

        public Criteria andAccAuthNotBetween(String value1, String value2) {
            addCriterion("ACC_AUTH not between", value1, value2, "accAuth");
            return (Criteria) this;
        }

        public Criteria andDataAuthIsNull() {
            addCriterion("DATA_AUTH is null");
            return (Criteria) this;
        }

        public Criteria andDataAuthIsNotNull() {
            addCriterion("DATA_AUTH is not null");
            return (Criteria) this;
        }

        public Criteria andDataAuthEqualTo(String value) {
            addCriterion("DATA_AUTH =", value, "dataAuth");
            return (Criteria) this;
        }

        public Criteria andDataAuthNotEqualTo(String value) {
            addCriterion("DATA_AUTH <>", value, "dataAuth");
            return (Criteria) this;
        }

        public Criteria andDataAuthGreaterThan(String value) {
            addCriterion("DATA_AUTH >", value, "dataAuth");
            return (Criteria) this;
        }

        public Criteria andDataAuthGreaterThanOrEqualTo(String value) {
            addCriterion("DATA_AUTH >=", value, "dataAuth");
            return (Criteria) this;
        }

        public Criteria andDataAuthLessThan(String value) {
            addCriterion("DATA_AUTH <", value, "dataAuth");
            return (Criteria) this;
        }

        public Criteria andDataAuthLessThanOrEqualTo(String value) {
            addCriterion("DATA_AUTH <=", value, "dataAuth");
            return (Criteria) this;
        }

        public Criteria andDataAuthLike(String value) {
            addCriterion("DATA_AUTH like", value, "dataAuth");
            return (Criteria) this;
        }

        public Criteria andDataAuthNotLike(String value) {
            addCriterion("DATA_AUTH not like", value, "dataAuth");
            return (Criteria) this;
        }

        public Criteria andDataAuthIn(List<String> values) {
            addCriterion("DATA_AUTH in", values, "dataAuth");
            return (Criteria) this;
        }

        public Criteria andDataAuthNotIn(List<String> values) {
            addCriterion("DATA_AUTH not in", values, "dataAuth");
            return (Criteria) this;
        }

        public Criteria andDataAuthBetween(String value1, String value2) {
            addCriterion("DATA_AUTH between", value1, value2, "dataAuth");
            return (Criteria) this;
        }

        public Criteria andDataAuthNotBetween(String value1, String value2) {
            addCriterion("DATA_AUTH not between", value1, value2, "dataAuth");
            return (Criteria) this;
        }

        public Criteria andStationAuthIsNull() {
            addCriterion("STATION_AUTH is null");
            return (Criteria) this;
        }

        public Criteria andStationAuthIsNotNull() {
            addCriterion("STATION_AUTH is not null");
            return (Criteria) this;
        }

        public Criteria andStationAuthEqualTo(String value) {
            addCriterion("STATION_AUTH =", value, "stationAuth");
            return (Criteria) this;
        }

        public Criteria andStationAuthNotEqualTo(String value) {
            addCriterion("STATION_AUTH <>", value, "stationAuth");
            return (Criteria) this;
        }

        public Criteria andStationAuthGreaterThan(String value) {
            addCriterion("STATION_AUTH >", value, "stationAuth");
            return (Criteria) this;
        }

        public Criteria andStationAuthGreaterThanOrEqualTo(String value) {
            addCriterion("STATION_AUTH >=", value, "stationAuth");
            return (Criteria) this;
        }

        public Criteria andStationAuthLessThan(String value) {
            addCriterion("STATION_AUTH <", value, "stationAuth");
            return (Criteria) this;
        }

        public Criteria andStationAuthLessThanOrEqualTo(String value) {
            addCriterion("STATION_AUTH <=", value, "stationAuth");
            return (Criteria) this;
        }

        public Criteria andStationAuthLike(String value) {
            addCriterion("STATION_AUTH like", value, "stationAuth");
            return (Criteria) this;
        }

        public Criteria andStationAuthNotLike(String value) {
            addCriterion("STATION_AUTH not like", value, "stationAuth");
            return (Criteria) this;
        }

        public Criteria andStationAuthIn(List<String> values) {
            addCriterion("STATION_AUTH in", values, "stationAuth");
            return (Criteria) this;
        }

        public Criteria andStationAuthNotIn(List<String> values) {
            addCriterion("STATION_AUTH not in", values, "stationAuth");
            return (Criteria) this;
        }

        public Criteria andStationAuthBetween(String value1, String value2) {
            addCriterion("STATION_AUTH between", value1, value2, "stationAuth");
            return (Criteria) this;
        }

        public Criteria andStationAuthNotBetween(String value1, String value2) {
            addCriterion("STATION_AUTH not between", value1, value2, "stationAuth");
            return (Criteria) this;
        }

        public Criteria andCheckAtuthIsNull() {
            addCriterion("CHECK_ATUTH is null");
            return (Criteria) this;
        }

        public Criteria andCheckAtuthIsNotNull() {
            addCriterion("CHECK_ATUTH is not null");
            return (Criteria) this;
        }

        public Criteria andCheckAtuthEqualTo(String value) {
            addCriterion("CHECK_ATUTH =", value, "checkAtuth");
            return (Criteria) this;
        }

        public Criteria andCheckAtuthNotEqualTo(String value) {
            addCriterion("CHECK_ATUTH <>", value, "checkAtuth");
            return (Criteria) this;
        }

        public Criteria andCheckAtuthGreaterThan(String value) {
            addCriterion("CHECK_ATUTH >", value, "checkAtuth");
            return (Criteria) this;
        }

        public Criteria andCheckAtuthGreaterThanOrEqualTo(String value) {
            addCriterion("CHECK_ATUTH >=", value, "checkAtuth");
            return (Criteria) this;
        }

        public Criteria andCheckAtuthLessThan(String value) {
            addCriterion("CHECK_ATUTH <", value, "checkAtuth");
            return (Criteria) this;
        }

        public Criteria andCheckAtuthLessThanOrEqualTo(String value) {
            addCriterion("CHECK_ATUTH <=", value, "checkAtuth");
            return (Criteria) this;
        }

        public Criteria andCheckAtuthLike(String value) {
            addCriterion("CHECK_ATUTH like", value, "checkAtuth");
            return (Criteria) this;
        }

        public Criteria andCheckAtuthNotLike(String value) {
            addCriterion("CHECK_ATUTH not like", value, "checkAtuth");
            return (Criteria) this;
        }

        public Criteria andCheckAtuthIn(List<String> values) {
            addCriterion("CHECK_ATUTH in", values, "checkAtuth");
            return (Criteria) this;
        }

        public Criteria andCheckAtuthNotIn(List<String> values) {
            addCriterion("CHECK_ATUTH not in", values, "checkAtuth");
            return (Criteria) this;
        }

        public Criteria andCheckAtuthBetween(String value1, String value2) {
            addCriterion("CHECK_ATUTH between", value1, value2, "checkAtuth");
            return (Criteria) this;
        }

        public Criteria andCheckAtuthNotBetween(String value1, String value2) {
            addCriterion("CHECK_ATUTH not between", value1, value2, "checkAtuth");
            return (Criteria) this;
        }

        public Criteria andReviewAuthIsNull() {
            addCriterion("REVIEW_AUTH is null");
            return (Criteria) this;
        }

        public Criteria andReviewAuthIsNotNull() {
            addCriterion("REVIEW_AUTH is not null");
            return (Criteria) this;
        }

        public Criteria andReviewAuthEqualTo(String value) {
            addCriterion("REVIEW_AUTH =", value, "reviewAuth");
            return (Criteria) this;
        }

        public Criteria andReviewAuthNotEqualTo(String value) {
            addCriterion("REVIEW_AUTH <>", value, "reviewAuth");
            return (Criteria) this;
        }

        public Criteria andReviewAuthGreaterThan(String value) {
            addCriterion("REVIEW_AUTH >", value, "reviewAuth");
            return (Criteria) this;
        }

        public Criteria andReviewAuthGreaterThanOrEqualTo(String value) {
            addCriterion("REVIEW_AUTH >=", value, "reviewAuth");
            return (Criteria) this;
        }

        public Criteria andReviewAuthLessThan(String value) {
            addCriterion("REVIEW_AUTH <", value, "reviewAuth");
            return (Criteria) this;
        }

        public Criteria andReviewAuthLessThanOrEqualTo(String value) {
            addCriterion("REVIEW_AUTH <=", value, "reviewAuth");
            return (Criteria) this;
        }

        public Criteria andReviewAuthLike(String value) {
            addCriterion("REVIEW_AUTH like", value, "reviewAuth");
            return (Criteria) this;
        }

        public Criteria andReviewAuthNotLike(String value) {
            addCriterion("REVIEW_AUTH not like", value, "reviewAuth");
            return (Criteria) this;
        }

        public Criteria andReviewAuthIn(List<String> values) {
            addCriterion("REVIEW_AUTH in", values, "reviewAuth");
            return (Criteria) this;
        }

        public Criteria andReviewAuthNotIn(List<String> values) {
            addCriterion("REVIEW_AUTH not in", values, "reviewAuth");
            return (Criteria) this;
        }

        public Criteria andReviewAuthBetween(String value1, String value2) {
            addCriterion("REVIEW_AUTH between", value1, value2, "reviewAuth");
            return (Criteria) this;
        }

        public Criteria andReviewAuthNotBetween(String value1, String value2) {
            addCriterion("REVIEW_AUTH not between", value1, value2, "reviewAuth");
            return (Criteria) this;
        }

        public Criteria andBuildAuthIsNull() {
            addCriterion("BUILD_AUTH is null");
            return (Criteria) this;
        }

        public Criteria andBuildAuthIsNotNull() {
            addCriterion("BUILD_AUTH is not null");
            return (Criteria) this;
        }

        public Criteria andBuildAuthEqualTo(String value) {
            addCriterion("BUILD_AUTH =", value, "buildAuth");
            return (Criteria) this;
        }

        public Criteria andBuildAuthNotEqualTo(String value) {
            addCriterion("BUILD_AUTH <>", value, "buildAuth");
            return (Criteria) this;
        }

        public Criteria andBuildAuthGreaterThan(String value) {
            addCriterion("BUILD_AUTH >", value, "buildAuth");
            return (Criteria) this;
        }

        public Criteria andBuildAuthGreaterThanOrEqualTo(String value) {
            addCriterion("BUILD_AUTH >=", value, "buildAuth");
            return (Criteria) this;
        }

        public Criteria andBuildAuthLessThan(String value) {
            addCriterion("BUILD_AUTH <", value, "buildAuth");
            return (Criteria) this;
        }

        public Criteria andBuildAuthLessThanOrEqualTo(String value) {
            addCriterion("BUILD_AUTH <=", value, "buildAuth");
            return (Criteria) this;
        }

        public Criteria andBuildAuthLike(String value) {
            addCriterion("BUILD_AUTH like", value, "buildAuth");
            return (Criteria) this;
        }

        public Criteria andBuildAuthNotLike(String value) {
            addCriterion("BUILD_AUTH not like", value, "buildAuth");
            return (Criteria) this;
        }

        public Criteria andBuildAuthIn(List<String> values) {
            addCriterion("BUILD_AUTH in", values, "buildAuth");
            return (Criteria) this;
        }

        public Criteria andBuildAuthNotIn(List<String> values) {
            addCriterion("BUILD_AUTH not in", values, "buildAuth");
            return (Criteria) this;
        }

        public Criteria andBuildAuthBetween(String value1, String value2) {
            addCriterion("BUILD_AUTH between", value1, value2, "buildAuth");
            return (Criteria) this;
        }

        public Criteria andBuildAuthNotBetween(String value1, String value2) {
            addCriterion("BUILD_AUTH not between", value1, value2, "buildAuth");
            return (Criteria) this;
        }

        public Criteria andTaskAuthIsNull() {
            addCriterion("TASK_AUTH is null");
            return (Criteria) this;
        }

        public Criteria andTaskAuthIsNotNull() {
            addCriterion("TASK_AUTH is not null");
            return (Criteria) this;
        }

        public Criteria andTaskAuthEqualTo(String value) {
            addCriterion("TASK_AUTH =", value, "taskAuth");
            return (Criteria) this;
        }

        public Criteria andTaskAuthNotEqualTo(String value) {
            addCriterion("TASK_AUTH <>", value, "taskAuth");
            return (Criteria) this;
        }

        public Criteria andTaskAuthGreaterThan(String value) {
            addCriterion("TASK_AUTH >", value, "taskAuth");
            return (Criteria) this;
        }

        public Criteria andTaskAuthGreaterThanOrEqualTo(String value) {
            addCriterion("TASK_AUTH >=", value, "taskAuth");
            return (Criteria) this;
        }

        public Criteria andTaskAuthLessThan(String value) {
            addCriterion("TASK_AUTH <", value, "taskAuth");
            return (Criteria) this;
        }

        public Criteria andTaskAuthLessThanOrEqualTo(String value) {
            addCriterion("TASK_AUTH <=", value, "taskAuth");
            return (Criteria) this;
        }

        public Criteria andTaskAuthLike(String value) {
            addCriterion("TASK_AUTH like", value, "taskAuth");
            return (Criteria) this;
        }

        public Criteria andTaskAuthNotLike(String value) {
            addCriterion("TASK_AUTH not like", value, "taskAuth");
            return (Criteria) this;
        }

        public Criteria andTaskAuthIn(List<String> values) {
            addCriterion("TASK_AUTH in", values, "taskAuth");
            return (Criteria) this;
        }

        public Criteria andTaskAuthNotIn(List<String> values) {
            addCriterion("TASK_AUTH not in", values, "taskAuth");
            return (Criteria) this;
        }

        public Criteria andTaskAuthBetween(String value1, String value2) {
            addCriterion("TASK_AUTH between", value1, value2, "taskAuth");
            return (Criteria) this;
        }

        public Criteria andTaskAuthNotBetween(String value1, String value2) {
            addCriterion("TASK_AUTH not between", value1, value2, "taskAuth");
            return (Criteria) this;
        }

        public Criteria andUserAuthIsNull() {
            addCriterion("USER_AUTH is null");
            return (Criteria) this;
        }

        public Criteria andUserAuthIsNotNull() {
            addCriterion("USER_AUTH is not null");
            return (Criteria) this;
        }

        public Criteria andUserAuthEqualTo(String value) {
            addCriterion("USER_AUTH =", value, "userAuth");
            return (Criteria) this;
        }

        public Criteria andUserAuthNotEqualTo(String value) {
            addCriterion("USER_AUTH <>", value, "userAuth");
            return (Criteria) this;
        }

        public Criteria andUserAuthGreaterThan(String value) {
            addCriterion("USER_AUTH >", value, "userAuth");
            return (Criteria) this;
        }

        public Criteria andUserAuthGreaterThanOrEqualTo(String value) {
            addCriterion("USER_AUTH >=", value, "userAuth");
            return (Criteria) this;
        }

        public Criteria andUserAuthLessThan(String value) {
            addCriterion("USER_AUTH <", value, "userAuth");
            return (Criteria) this;
        }

        public Criteria andUserAuthLessThanOrEqualTo(String value) {
            addCriterion("USER_AUTH <=", value, "userAuth");
            return (Criteria) this;
        }

        public Criteria andUserAuthLike(String value) {
            addCriterion("USER_AUTH like", value, "userAuth");
            return (Criteria) this;
        }

        public Criteria andUserAuthNotLike(String value) {
            addCriterion("USER_AUTH not like", value, "userAuth");
            return (Criteria) this;
        }

        public Criteria andUserAuthIn(List<String> values) {
            addCriterion("USER_AUTH in", values, "userAuth");
            return (Criteria) this;
        }

        public Criteria andUserAuthNotIn(List<String> values) {
            addCriterion("USER_AUTH not in", values, "userAuth");
            return (Criteria) this;
        }

        public Criteria andUserAuthBetween(String value1, String value2) {
            addCriterion("USER_AUTH between", value1, value2, "userAuth");
            return (Criteria) this;
        }

        public Criteria andUserAuthNotBetween(String value1, String value2) {
            addCriterion("USER_AUTH not between", value1, value2, "userAuth");
            return (Criteria) this;
        }

        public Criteria andCustomAuthIsNull() {
            addCriterion("CUSTOM_AUTH is null");
            return (Criteria) this;
        }

        public Criteria andCustomAuthIsNotNull() {
            addCriterion("CUSTOM_AUTH is not null");
            return (Criteria) this;
        }

        public Criteria andCustomAuthEqualTo(String value) {
            addCriterion("CUSTOM_AUTH =", value, "customAuth");
            return (Criteria) this;
        }

        public Criteria andCustomAuthNotEqualTo(String value) {
            addCriterion("CUSTOM_AUTH <>", value, "customAuth");
            return (Criteria) this;
        }

        public Criteria andCustomAuthGreaterThan(String value) {
            addCriterion("CUSTOM_AUTH >", value, "customAuth");
            return (Criteria) this;
        }

        public Criteria andCustomAuthGreaterThanOrEqualTo(String value) {
            addCriterion("CUSTOM_AUTH >=", value, "customAuth");
            return (Criteria) this;
        }

        public Criteria andCustomAuthLessThan(String value) {
            addCriterion("CUSTOM_AUTH <", value, "customAuth");
            return (Criteria) this;
        }

        public Criteria andCustomAuthLessThanOrEqualTo(String value) {
            addCriterion("CUSTOM_AUTH <=", value, "customAuth");
            return (Criteria) this;
        }

        public Criteria andCustomAuthLike(String value) {
            addCriterion("CUSTOM_AUTH like", value, "customAuth");
            return (Criteria) this;
        }

        public Criteria andCustomAuthNotLike(String value) {
            addCriterion("CUSTOM_AUTH not like", value, "customAuth");
            return (Criteria) this;
        }

        public Criteria andCustomAuthIn(List<String> values) {
            addCriterion("CUSTOM_AUTH in", values, "customAuth");
            return (Criteria) this;
        }

        public Criteria andCustomAuthNotIn(List<String> values) {
            addCriterion("CUSTOM_AUTH not in", values, "customAuth");
            return (Criteria) this;
        }

        public Criteria andCustomAuthBetween(String value1, String value2) {
            addCriterion("CUSTOM_AUTH between", value1, value2, "customAuth");
            return (Criteria) this;
        }

        public Criteria andCustomAuthNotBetween(String value1, String value2) {
            addCriterion("CUSTOM_AUTH not between", value1, value2, "customAuth");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}